#include <cuda_runtime.h>
#include <math.h>
#include <helper_math.h>

#include "BBox.h"
#include "Bounce.h"

// RX^gD
__device__ unsigned int d_col_2OBB_2obj[MAX_NUM_CRASH_BBOX_PAIRS];
__constant__ float4 d_rot_pos[NUM_OBJECTS][4];

// e_̍WƖ@D
extern float4 *h_vertex; 
extern float4 *h_normal;
extern float4 *d_vertex;
extern float4 *d_normal;

extern int3 (*d_col_2OBB_DB)[2];
extern col_point *d_col_point;

extern float4 cross(float4 a, float4 b);
extern float4 mulMV(float4 *a, float4 v);

// |Sm̏Փ˔D
// CPUGPȖxr̂߂ɁCGPUg킸ɎD
void h_detectColPolys(float4 *vertex, float4 *normal, unsigned int num_col_2OBB, int3 col_2OBB_DB[][2], unsigned int col_2OBB_2obj[], float4 rot_pos[][4], col_point h_col_point[])
// float4 *vertex; IuWFNg̒_D
// float4 *normal; IuWFNg̖@D
// unsigned int num_col_2OBB; Փ˂ĂOBB̑g̐D
// int3 col_2OBB_DB[][2]; 2OBB̂ꂼɕ܂Ă钸_ւ̃CfbNXƃ|SƑΉIuWFNgD
// unsigned int col_2OBB_2obj[]; Փ˂ĂOBB̑gƃIuWFNg̑g̊֘AD
// float4 rot_pos[4]; eIuWFNg̎pϊsƈʒûD
// col_point h_col_point[]; Փ˓_Ɩ@̃f[^D
{
	unsigned int obj_idx, index;
	unsigned int i, j, OBB_pair, obj, tri, ed;
	unsigned int o_tri, o_obj;
	float d, t, du[2], di[3];
	float4 nrml, ver, i_pnt;
	float4 tri_ver[2][MAX_NUM_TRIS_IN_BBOX][3]; // [IuWFNg][|S][_]
	float4 tri_nrml[2][MAX_NUM_TRIS_IN_BBOX];	// [IuWFNg][|S]

	// SĂOBB̌yAɂďJԂD
	for (OBB_pair = 0; OBB_pair < num_col_2OBB; OBB_pair++) {

		// _Ɩ@f[^i[D
		for (obj = 0; obj < 2; obj++) {
			obj_idx = col_2OBB_DB[OBB_pair][obj].z; 
			for (tri = 0; tri < (unsigned int)(col_2OBB_DB[OBB_pair][obj].y); tri++) {
				nrml = normal[col_2OBB_DB[OBB_pair][obj].x + tri * 3];
				tri_nrml[obj][tri] = mulMV(rot_pos[obj_idx], nrml);
				for (ed = 0; ed < 3; ed++) {
					ver = vertex[col_2OBB_DB[OBB_pair][obj].x + tri * 3 + ed];
					tri_ver[obj][tri][ed] = mulMV(rot_pos[obj_idx], ver) + rot_pos[obj_idx][3];
				}
			}
		}

		// IuWFNgԂ̏Փ˂j[NɈCfbNXD
		index = col_2OBB_2obj[OBB_pair];

		// IuWFNg0ƃIuWFNg1ŖサČ݂ɌvZD
		for (obj = 0; obj < 2; obj++) {

			// ̃IuWFNgD
			o_obj = (obj + 1) % 2;

			// Е̃|S̗אڂ̒_ԐƁC̃|Š𒲂ׂD
			for(i = 0; i < (unsigned int)(col_2OBB_DB[OBB_pair][0].y); i++) {
				for(j = 0; j < (unsigned int)(col_2OBB_DB[OBB_pair][1].y); j++) {
					if (obj == 0) {
						tri = i; o_tri = j;
					} else {
						tri = j; o_tri = i;
					}

					// ̃|S܂ޕʂ̒̕萔D
					d = - dot(tri_nrml[o_obj][o_tri], tri_ver[o_obj][o_tri][0]);

					// |S̗אڂ̒_̍W𕽖ʂ֑̕Ct𓾂D
					for (ed = 0; ed < 3; ed++) {
						du[0] = dot(tri_nrml[o_obj][o_tri], tri_ver[obj][tri][ed]) + d;
						du[1] = dot(tri_nrml[o_obj][o_tri], tri_ver[obj][tri][(ed + 1) % 3]) + d;

						// 2̒_ʂ̈قȂ鑤ɂD
						if (du[0] * du[1] < 0.0f) { 

							// _𓾂D
							t = du[0] / (du[0] - du[1]);
							i_pnt = tri_ver[obj][tri][ed] + t * (tri_ver[obj][tri][(ed + 1) % 3] - tri_ver[obj][tri][ed]);

							// _|Sɂ邩ǂ̊mFD
							di[0] = dot(cross((tri_ver[o_obj][o_tri][1] - tri_ver[o_obj][o_tri][0]), (i_pnt - tri_ver[o_obj][o_tri][0])), tri_nrml[o_obj][o_tri]);
							di[1] = dot(cross((tri_ver[o_obj][o_tri][2] - tri_ver[o_obj][o_tri][1]), (i_pnt - tri_ver[o_obj][o_tri][1])), tri_nrml[o_obj][o_tri]);
							di[2] = dot(cross((tri_ver[o_obj][o_tri][0] - tri_ver[o_obj][o_tri][2]), (i_pnt - tri_ver[o_obj][o_tri][2])), tri_nrml[o_obj][o_tri]);
							if((di[0] * di[2]) > 0.0f && (di[1] * di[2]) > 0.0f){

								//Փ˓_ł̍WƖ@f[^̊i[D
								h_col_point[index].pnt = i_pnt;
								h_col_point[index].nrml = tri_nrml[o_obj][o_tri];
								h_col_point[index].nrml.w = (float)obj; // wvfɕtIȃf[^ĂD

								// łՓ˂Ĉ̗̃yAɂĂ͒T߂D
								goto try_next_pair;
							}
						}
					}
				}
			}
		}
		try_next_pair:;
	}
}

// CPUp|Sm̏Փ˔̋ND
void launchCPUDetectColPolys(unsigned int num_contacts, unsigned int num_col_2OBB, int3 col_2OBB_DB[][2], unsigned int col_2OBB_2obj[], float4 rot_pos[][4], col_point col_point[])
// unsigned int num_contacts; Փ˂ĂIuWFNg̑g̐D
// unsigned int num_col_2OBB; Փ˂ĂOBB̑g̐D
// int3 col_2OBB_DB[][2]; 2OBB̂ꂼɕ܂Ă钸_ւ̃CfbNXƃ|SƑΉIuWFNgD
// unsigned int col_2OBB_2obj[]; Փ˂ĂOBB̑gƃIuWFNg̑g̊֘AD
// float4 rot_pos[4]; eIuWFNg̎pϊsƈʒûD
// col_point col_point[]; zXgɕԂՓ˓_Ɩ@̃f[^D
{  

    // CPUł̎Op`̌D
    h_detectColPolys(h_vertex, h_normal, num_col_2OBB, col_2OBB_DB, col_2OBB_2obj, rot_pos, col_point);
}

// xNg̓ρD
__device__ float d_dot(float4 a, float4 b)
// float4 a, b; ̃xNgDa dot b̌vZD
{
	return a.x * b.x + a.y * b.y + a.z * b.z;
}

// xNg̊OρDʂ͕xNgȂ̂wvf͏0.0D
__device__ float4 d_cross(float4 a, float4 b)
// float a, b; 2̃xNgD
{
	return make_float4(a.y * b.z - a.z * b.y, a.z * b.x - a.x * b.z, a.x * b.y - a.y * b.x, 0.0f);
}

// xNgւ̍s̓KpD
// a x vDʒuxNgxNg̉]ϊ
__device__ float4 d_mulMV(float4 *a, float4 v)
// float4 *a; 4~4sD
// float4 v; ʒuxNgxNgDwvf͖D
{
	return make_float4(a[0].x * v.x + a[1].x * v.y + a[2].x * v.z,
		a[0].y * v.x + a[1].y * v.y + a[2].y * v.z,
		a[0].z * v.x + a[1].z * v.y + a[2].z * v.z, 
		1.0f); // vxNgȂ0.0fԂׂDDD
}

// |Sm̏Փ˔D
// GPUŁD
__global__ void d_detectColPolys(float4 *vertex, float4 *normal, int3 d_col_2OBB_DB[][2], col_point d_col_point[])
// float4 *vertex; IuWFNg̒_D
// float4 *normal; IuWFNg̖@D
// int3 d_col_2OBB_DB[][2]; 2OBB̂ꂼɕ܂Ă|S̒_ւ̃CfbNXƃ|SƑΉIuWFNgD
// col_point d_col_point[]; Փ˓_Ɩ@̃f[^D
{
	unsigned int i, obj_idx, index;
	unsigned int obb = threadIdx.x;		// OBB0OBB1D[0, 1]D
	unsigned int tri = threadIdx.y;		// |ŜǂꂩD[0, ..., (MAX_NUM_TRIS_IN_BBOX - 1)]D
	unsigned int ed = threadIdx.z;		// |S3̕ӂ̂ǂꂩD[0, 1, 2]D
	unsigned int o_obb;
	float d, t, du[2], di[3];
	float4 nrml, ver, int_point;
	__shared__ float4 tri_ver[2][MAX_NUM_TRIS_IN_BBOX][3];	// [IuWFNg][|S][_]
	__shared__ float4 tri_nrml[2][MAX_NUM_TRIS_IN_BBOX];	// [IuWFNg][|S]

	// Xbh|S͈̔͂𒴂ĂD
	if (tri >= d_col_2OBB_DB[blockIdx.x][obb].y)
		return;

	// VFA[hɒ_Ɩ@f[^i[D
	obj_idx = d_col_2OBB_DB[blockIdx.x][obb].z;
    ver = vertex[d_col_2OBB_DB[blockIdx.x][obb].x + tri * 3 + ed];
	tri_ver[obb][tri][ed] = d_mulMV(d_rot_pos[obj_idx], ver) + d_rot_pos[obj_idx][3];
	nrml = normal[d_col_2OBB_DB[blockIdx.x][obb].x + tri * 3];
	tri_nrml[obb][tri] = d_mulMV(d_rot_pos[obj_idx], nrml);
	__syncthreads();

	// ̃IuWFNgD
	o_obb = (obb + 1) % 2; 

	// IuWFNgԂ̏Փ˂j[NɈCfbNXD
	index = d_col_2OBB_2obj[blockIdx.x];

	// Е̃|S1ӂƁC̃|Š𒲂ׂD
	for (i = 0; i < d_col_2OBB_DB[blockIdx.x][o_obb].y; i++) { 

		// ̃|S܂ޕʂ̒̕萔D
		d = - d_dot(tri_nrml[o_obb][i], tri_ver[o_obb][i][0]);

		// ӂ̗[̒_̍W𕽖ʂ֑̕Ct𓾂D
		du[0] = d_dot(tri_nrml[o_obb][i], tri_ver[obb][tri][ed]) + d;
		du[1] = d_dot(tri_nrml[o_obb][i], tri_ver[obb][tri][(ed + 1) % 3]) + d;

		// 2̒_ʂ̈قȂ鑤ɂD
		if (du[0] * du[1] < 0.0f) { 

			// _𓾂D
			t = du[0] / (du[0] - du[1]);
			int_point = tri_ver[obb][tri][ed] + t * (tri_ver[obb][tri][(ed + 1) % 3] - tri_ver[obb][tri][ed]);

			// _|Sɂ邩ǂ̊mFD
			di[0] = d_dot(d_cross((tri_ver[o_obb][i][1] - tri_ver[o_obb][i][0]), (int_point - tri_ver[o_obb][i][0])), tri_nrml[o_obb][i]);
			di[1] = d_dot(d_cross((tri_ver[o_obb][i][2] - tri_ver[o_obb][i][1]), (int_point - tri_ver[o_obb][i][1])), tri_nrml[o_obb][i]);
			di[2] = d_dot(d_cross((tri_ver[o_obb][i][0] - tri_ver[o_obb][i][2]), (int_point - tri_ver[o_obb][i][2])), tri_nrml[o_obb][i]);
			if ((di[0] * di[2]) > 0.0f && (di[1] * di[2]) > 0.0f) {

				// Փ˓_̍WƖ@f[^̊i[D
				d_col_point[index].pnt = int_point;
				d_col_point[index].nrml = tri_nrml[o_obb][i];
				d_col_point[index].nrml.w = (float)obb;

				// 1łՓ˂瑦ɏID
				return;
			}
		}
	}
}

// GPUp|Sm̏Փ˔̋ND
void launchGPUDetectColPolys(unsigned int num_contacts, unsigned int num_col_2OBB, int3 col_2OBB_DB[][2], unsigned int col_2OBB_2obj[], float4 rot_pos[][4], col_point col_point[])
// unsigned int num_contacts; Փ˂ĂIuWFNg̑g̐D
// unsigned int num_col_2OBB; Փ˂ĂOBB̑g̐D
// int3 col_2OBB_DB[][2]; 2OBB̂ꂼɕ܂Ă钸_ւ̃CfbNXƃ|SƑΉIuWFNgD
// unsigned int col_2OBB_2obj[]; Փ˂ĂOBB̑gƃIuWFNg̑g̊֘AD
// float4 rot_pos[4]; eIuWFNg̎pϊsƈʒuD
// col_point col_point[]; zXgɕԂՓ˓_Ɩ@̃f[^D
{
	dim3 grid, block;

	// ObhƃubN̒`D
	grid = dim3(num_col_2OBB, 1); 
	block = dim3(2, MAX_NUM_TRIS_IN_BBOX, 3);

	// zXg̃f[^foCX̃ɃRs[D
	cudaMemcpy(d_col_2OBB_DB, col_2OBB_DB, num_col_2OBB * 2 * sizeof(int3), cudaMemcpyHostToDevice);
	cudaMemcpyToSymbol(d_col_2OBB_2obj, col_2OBB_2obj, num_col_2OBB * sizeof(unsigned int), 0, cudaMemcpyHostToDevice);
	cudaMemcpyToSymbol(d_rot_pos, rot_pos, NUM_OBJECTS * 4 * sizeof(float4), 0, cudaMemcpyHostToDevice);
	cudaMemcpy(d_col_point, col_point, num_contacts * 2 * sizeof(float4), cudaMemcpyHostToDevice);

	// Op`|SԂ̌D
	d_detectColPolys <<< grid, block >>> (d_vertex, d_normal, d_col_2OBB_DB, d_col_point);

	// Փ˃f[^zXg̃ɃRs[D
	cudaMemcpy(col_point, d_col_point, 2 * num_contacts * sizeof(float4), cudaMemcpyDeviceToHost);
}
