#include "stdafx.h"
#include <gl/freeglut.h>

#define X 0
#define Y 1
#define Z 2

unsigned int num_points = 8;
double point[][3] = {{1.0, 1.0, -1.0}, {-1.0, 1.0, -1.0}, {-1.0, -1.0, -1.0}, {1.0, -1.0, -1.0}, {1.0, 1.0, 1.0}, {-1.0, 1.0, 1.0}, {-1.0, -1.0, 1.0}, {1.0, -1.0, 1.0}};

unsigned int window_width;
unsigned int window_height;

double init_left = -2.0;
double init_right = 2.0;
double init_bottom = -2.0;
double init_top = 2.0;

double left, right, bottom, top;

double eye[3] = {2.0, 1.0, 1.0};
double center[3] = {0.0, 0.0, 0.0};
double up[3] = {0.0, 0.0, 1.0};

void display(void)
{	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(left, right, bottom, top, -100.0, 100.0);
	glViewport(0, 0, window_width, window_height);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(eye[X], eye[Y], eye[Z], center[X], center[Y], center[Z], up[X], up[Y], up[Z]); 

	glClear(GL_COLOR_BUFFER_BIT);
	glBegin(GL_LINES);

	glVertex3dv(point[0]);
	glVertex3dv(point[1]);

	glVertex3dv(point[1]);
	glVertex3dv(point[2]);

	glVertex3dv(point[2]);
	glVertex3dv(point[3]);
	
	glVertex3dv(point[3]);
	glVertex3dv(point[0]);

	glVertex3dv(point[4]);
	glVertex3dv(point[5]);

	glVertex3dv(point[5]);
	glVertex3dv(point[6]);

	glVertex3dv(point[6]);
	glVertex3dv(point[7]);
	
	glVertex3dv(point[7]);
	glVertex3dv(point[4]);

	glVertex3dv(point[0]);
	glVertex3dv(point[4]);

	glVertex3dv(point[1]);
	glVertex3dv(point[5]);

	glVertex3dv(point[2]);
	glVertex3dv(point[6]);
	
	glVertex3dv(point[3]);
	glVertex3dv(point[7]);

	glEnd();
	glFlush();
}

void resize(int width, int height)
{
	unsigned int i;
	double dx, dy, d_aspect, w_aspect, d;
	double margin;

	// EBhETCY̎擾D
	window_width = width;
	window_height = height;

	// W͈̔͂̓ǂݎD
	init_left = init_bottom = 10000.0;
	init_right = init_top = -10000.0;
	for (i = 0; i < num_points; i++) {
		if (point[i][X] < init_left)
			init_left = point[i][X];
		if (point[i][X] > init_right)
			init_right = point[i][X];
		if (point[i][Y] < init_bottom)
			init_bottom = point[i][Y];
		if (point[i][Y] > init_top)
			init_top = point[i][Y];
	}

	// ͂5%LD
	margin = (init_right - init_left) * 0.05;
	init_left -= margin;
	init_right += margin;
	margin = (init_top - init_bottom) * 0.05;
	init_bottom -= margin;
	init_top += margin;

	// \͈͂̃AXyNgƃEBhẼAXyNg̔rD
	dx = init_right - init_left;
	dy = init_top - init_bottom;
	d_aspect = dy / dx;
	w_aspect = (double)window_height / (double)window_width;

	
	// EBhE\͈͂cD\͈͂cɍLD
	if (w_aspect > d_aspect) {
		d = (dy * (w_aspect / d_aspect - 1.0)) * 0.5;
		left = init_left;
		right = init_right;
		bottom = init_bottom - d;
		top = init_top + d;

		// EBhE\͈͂D\͈͂ɍLD
	} else {
		d = (dx * (d_aspect / w_aspect - 1.0)) * 0.5;
		left = init_left - d;
		right = init_right + d;
		bottom = init_bottom;
		top = init_top;
	}
}

void initGL(void)
{
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
}

int main(int argc, char *argv[])
{
	glutInitWindowPosition(128, 128); // EBhȄʒuD
	glutInitWindowSize(768, 768); // EBhETCY`D
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA);
	glutCreateWindow(argv[0]);
	glutDisplayFunc(display);
	glutReshapeFunc(resize);
	initGL();
	glutMainLoop();
	return 0;
}
