#include <math.h>

#define PI 3.141592653589793

// CPUD
#define h_U(x, y, t) (- 2.0f * (float)cos(PI * (t) / 8.0f) * (float)sin(PI * (x)) * (float)sin(PI * (x)) * (float)cos(PI * (y)) * (float)sin(PI * (y)))
#define h_V(x, y, t) (2.0f * (float)cos(PI * (t) / 8.0f) * (float)cos(PI * (x)) * (float)sin(PI * (x)) * (float)sin(PI * (y)) * (float)sin(PI * (y)))

// CPUpQENb^@D
void h_RungeKutta(unsigned int index, float (*pos)[2], float time, float dt)
// unsigned int index; q̃CfbNXD
// float (*pos)[2]; qʒuD
// float time; D
// float dt; ԍ݁D
{
 	float xn, yn, p1, q1, p2, q2, p3, q3, p4, q4;
	float x, y, t;
    xn = pos[index][0];
    yn = pos[index][1];

    // 1iځD
	p1 = h_U(xn, yn, time);
	q1 = h_V(xn, yn, time);

	// 2iځD
	x = xn + 0.5f * p1 * dt;
	y = yn + 0.5f * q1 * dt;
	t = time + 0.5f * dt;
	p2 = h_U(x, y, t);
	q2 = h_V(x, y, t);

	// 3iځD
	x = xn + 0.5f * p2 * dt;
	y = yn + 0.5f * q2 * dt;
	t = time + 0.5f * dt;
	p3 = h_U(x, y, t);
	q3 = h_V(x, y, t);

	// 4iځD
	x = xn + p3 * dt;
	y = yn + q3 * dt;
	t = time + dt;
	p4 = h_U(x, y, t);
	q4 = h_V(x, y, t);
   
    // qʒu̍XVD
    pos[index][0] = xn + (p1 + p2 + p3 + p4) / 6.0f * dt;
    pos[index][1] = yn + (q1 + q2 + q3 + q4) / 6.0f * dt;
}

// CPŰND
void launchCPUKernel(unsigned int num_particles, float (*pos)[2], float time, float dt)
// unsigned int num_particles; q̑D
// float (*pos)[2]; qʒuD
// float time; D
// float dt; ԍ݁D
{
    unsigned int i;
    for (i = 0; i < num_particles; i++)
        h_RungeKutta(i, pos, time, dt);
}
