#include <stdio.h>

// x̒l[a, b]͈̔͂ɃNvD
float h_clamp(float x, float a, float b)
{
	if (x < a)
		x = a;
	if (x > b)
		x = b;
	return x;
}

// 0`255.0f̕_r, g, blFf[^𐶐D
int h_RGBToInt(float r, float g, float b)
{
    r = h_clamp(r, 0.0f, 255.0f);
    g = h_clamp(g, 0.0f, 255.0f);
    b = h_clamp(b, 0.0f, 255.0f);
    return (int(r) << 16) | (int(g) << 8) | int(b);
}

// CPUɂ鍷@vZD
void h_diffusion2D(unsigned int j, unsigned int i, float *F, float *Fn, unsigned int width, unsigned int height, float c0, float c1, float c2,
	float max_density, int *g_data)
// unsingned int j, i; iqXỸCfbNXD
// float *F; ݂̊iqf[^D
// float *Fn; XVꂽiqf[^D
// unsigned width, height; iqf[^XỶ𑜓xD
// float c0, c1, c2; @vŽWD
// float max_density; Zx̍őlD
// int *g_data; 摜f[^̏óD
{
    unsigned int index;
    float fc, fr, fl, fd, ft, density;

    // F[index]̎͂4vf(㉺E4vf)߂D
    index = width * i + j;
	fc = F[index];
    if (j == 0)
        fl = fc;
    else
        fl = F[index - 1];
    if (j == (width - 1)) 
        fr = fc;
    else             
        fr = F[index + 1];
	if (i == 0) 
        fd = fc;
    else        
        fd = F[index - width];
 	if (i == (height - 1))
        ft = fc;
    else             
        ft = F[index + width];
	Fn[index] = c0 * (fr + fl) + c1 * (ft + fd) + c2 * fc;
	density = 255.0f - Fn[index] / max_density * 255.5f;
	g_data[index] = h_RGBToInt(density, density, density);
}

// CPŰND
void launchCPUKernel(float *F, float *Fn, unsigned int width, unsigned int height, float dx, float dy, float kappa, float dt,
	float max_density, int *g_data)
// float *F; ݂̊iqf[^D
// float *Fn; XVꂽiqf[^D
// unsigned width, height; iqf[^XỶ𑜓xD
// float dx, dy; XY̊iqԊuD
// float kappa; gUWD
// float dt; ԊԊuD
// float max_density; Zx̍őlD
// int *g_data; 摜f[^̏óD
{
	unsigned int i, j;
    float c0, c1, c2;

    // @̌W̌D
    c0 = kappa * dt / (dx * dx);
    c1 = kappa * dt / (dy * dy);
    c2 = 1.0f - 2.0f * (c0 + c1);
	for (i = 0; i < height; i++) {
		for (j = 0; j < width; j++) {
			h_diffusion2D(j, i, F, Fn, width, height, c0, c1, c2, max_density, g_data);
		}
	}
}

// ubNTCY̒`D
#define  BLOCKDIM_X 16
#define  BLOCKDIM_Y 16

// x̒l[a, b]͈̔͂ɃNvD
__device__ float d_clamp(float x, float a, float b)
{
 	if (x < a)
		x = a;
	if (x > b)
		x = b;
	return x;
}

// 0`255.0f̕_r, g, blFf[^𐶐D
__device__ int d_RGBToInt(float r, float g, float b)
{
    r = d_clamp(r, 0.0f, 255.0f);
    g = d_clamp(g, 0.0f, 255.0f);
    b = d_clamp(b, 0.0f, 255.0f);
    return (int(r) << 16) | (int(g) << 8) | int(b);
}

// GPUɂ鍷@vZD
// O[o𒼐ڎQƂꍇD
__global__ void d_diffusion2D0(float *F, float *Fn, unsigned int width, unsigned int height, float c0, float c1, float c2,
	float max_density, int *g_data)
// float *F; ݂̊iqf[^D
// float *Fn; XVꂽiqf[^D
// unsigned width, height; iqf[^XỶ𑜓xD
// float c0, c1, c2; @vŽWD
// float max_density; Zx̍őlD
// int *g_data; 摜f[^̏óD
{
    unsigned int i, j, index;
    float fc, fr, fl, fd, ft, density;
    i = blockDim.y * blockIdx.y + threadIdx.y;
    j = blockDim.x * blockIdx.x + threadIdx.x;

	// iq͈̔͂̃`FbND
	if ((i >= height) || (j >= width))
		return;

    // F[index]̎͂4vf(㉺E4vf)߂D
    index = width * i + j;
    fc = F[index];
    if (j == 0)
        fl = fc;
    else
        fl = F[index - 1];
    if (j == (width - 1)) 
        fr = fc;
    else             
        fr = F[index + 1];
    if (i == 0) 
        fd = fc;
    else        
        fd = F[index - width];
    if (i == (height - 1))
        ft = fc;
    else             
        ft = F[index + width];
    Fn[index] = c0 * (fr + fl) + c1 * (ft + fd) + c2 * fc;
    density = 255.0f - Fn[index] / max_density * 255.5f;
	g_data[index] = d_RGBToInt(density, density, density);
}

// GPUɂ鍷@vZD
// VFA[hgꍇD
__global__ void  d_diffusion2D1(float *F, float *Fn, unsigned int width, unsigned int height, float c0, float c1, float c2,
	float max_density, int *g_data)
// float *F; ݂̊iqf[^D
// float *Fn; XVꂽiqf[^D
// unsigned width, height; iqf[^XỶ𑜓xD
// float c0, c1, c2; @vŽWD
// float max_density; Zx̍őlD
// int *g_data; 摜f[^̏óD
{
    unsigned int gi, gj, i, j, index;
    float fc, density;
    __shared__ float fs[BLOCKDIM_Y + 2][BLOCKDIM_X + 2];
    gi = blockDim.y * blockIdx.y + threadIdx.y;
    gj = blockDim.x * blockIdx.x + threadIdx.x;

	// iq͈̔͂̃`FbND
	if ((gi >= height) || (gj >= width))
		return;
 
    // VFA[hɁCubNE㉺1L͈͂̃f[^i[D
	index = width * gi + gj;
	i = threadIdx.y + 1;
    j = threadIdx.x + 1;
	fc = fs[i][j] = F[index];
    if (threadIdx.x == 0) { // ubN̍[D
        if (gj == 0) // iq̍[̏ꍇD
            fs[i][0] = fc; 
        else                
            fs[i][0] = F[index - 1];
    }
    if (threadIdx.x == (blockDim.x - 1)) { // ubN̉E[D
        if(gj == width - 1) // iq̉E[̏ꍇD
            fs[i][blockDim.x + 1] = fc;
        else                            
            fs[i][blockDim.x + 1] = F[index + 1];
    }
    if (threadIdx.y ==  0) { // ubN̉[D
        if (gi == 0) // iq̉[̏ꍇD
            fs[0][j] = fc;
        else 
            fs[0][j] = F[index - width];
    }
    if (threadIdx.y ==  blockDim.y - 1) { // ubN̏[D
        if (gi == height - 1) // iq̏[̏ꍇD
            fs[blockDim.y + 1][j] = fc;
        else                            
            fs[blockDim.y + 1][j] = F[index + width];
    }
    __syncthreads();
    Fn[index] = c0 * (fs[i][j + 1] + fs[i][j - 1]) + c1 * (fs[i + 1][j] + fs[i - 1][j])
        + c2 * fs[i][j];
    density = 255.0f - Fn[index] / max_density * 255.5f;
	g_data[index] = d_RGBToInt(density, density, density);
}

// CUDAeNX`D
texture<float, 1> tex_F;
texture<float, 1> tex_Fn;

// CUDAeNX`̃oChD
void bindTextures(float *F, float *Fn)
{
	cudaChannelFormatDesc desc = cudaCreateChannelDesc(32, 0, 0, 0, cudaChannelFormatKindFloat);
    cudaBindTexture(0, tex_F, F, desc);
    cudaBindTexture(0, tex_Fn, Fn, desc);
}

// CUDAeNX`̃AoChD
void unbindTextures(void)
{
	cudaUnbindTexture(tex_F);
    cudaUnbindTexture(tex_Fn);
}

// GPUɂ鍷@vZD
// eNX`QƂꍇD
__global__ void d_diffusion2D2(float *F, float *Fn, unsigned int width, unsigned int height, float c0, float c1, float c2,
    float max_density, bool direction, int *g_data)
// float *F; ݂̊iqf[^D
// float *Fn; XVꂽiqf[^D
// unsigned width, height; iqf[^XỶ𑜓xD
// float c0, c1, c2; @vŽWD
// float max_density; Zx̍őlD
// bool direction; trueȂtex_F, falseȂtex_FngD
// int *g_data; 摜f[^̏óD
{
    unsigned int i, j, index;
    float fc, fr, fl, fd, ft, density;
    i = blockDim.y * blockIdx.y + threadIdx.y;
    j = blockDim.x * blockIdx.x + threadIdx.x;

	// iq͈̔͂̃`FbND
	if ((i >= height) || (j >= width))
		return;

    // F[index]̎͂4vf(㉺E4vf)߂D
	index = width * i + j;
    if (direction) {
        fc = tex1Dfetch(tex_F, index);
        if (j == 0)
            fl = fc;
        else
            fl = tex1Dfetch(tex_F, index - 1);
        if (j == (width - 1)) 
            fr = fc;
        else             
            fr = tex1Dfetch(tex_F, index + 1);
        if (i == 0) 
            fd = fc;
        else        
            fd = tex1Dfetch(tex_F, index - width);
        if (i == (height - 1))
            ft = fc;
        else             
            ft = tex1Dfetch(tex_F, index + width);
    } else {
        fc = tex1Dfetch(tex_Fn, index);
        if (j == 0)
            fl = fc;
        else
            fl = tex1Dfetch(tex_Fn, index - 1);
        if (j == (width - 1)) 
            fr = fc;
        else             
            fr = tex1Dfetch(tex_Fn, index + 1);
        if (i == 0) 
            fd = fc;
        else        
            fd = tex1Dfetch(tex_Fn, index - width);
        if (i == (height - 1))
            ft = fc;
        else             
            ft = tex1Dfetch(tex_Fn, index + width);
    }
    Fn[index] = c0 * (fr + fl) + c1 * (ft + fd) + c2 * fc;
    density = 255.0f - Fn[index] / max_density * 255.5f;
	g_data[index] = d_RGBToInt(density, density, density);
}

// GPŰND
void launchGPUKernel(float *F, float *Fn, unsigned int width, unsigned int height, float dx, float dy, float kappa, float dt,
    float max_density, bool direction, int *g_data)
// float *F; ݂̊iqf[^D
// float *Fn; XVꂽiqf[^D
// unsigned width, height; iqf[^XỶ𑜓xD
// float dx, dy; XY̊iqԊuD
// float kappa; gUWD
// float dt; ԊԊuD
// float max_density; Zx̍őlD
// bool direction; ̕Dtrue̎F->FnCfalse̎Fn->FD
// int *g_data; 摜f[^̏óD
{
    float c0, c1, c2;

    // @̌W̌D
    c0 = kappa * dt / (dx * dx);
    c1 = kappa * dt / (dy * dy),
    c2 = 1.0f - 2.0f * (c0 + c1);

    // ObhTCYƃubNTCY̒`D
    dim3 grid(width / BLOCKDIM_X + 1, height / BLOCKDIM_Y + 1);
    dim3 block(BLOCKDIM_X, BLOCKDIM_Y, 1);
	d_diffusion2D2 <<< grid, block >>> (F, Fn, width, height, c0, c1, c2, max_density, direction, g_data);
}
